"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const sql_template_strings_1 = require("sql-template-strings");
function SQL(ss, ...args) {
    if (typeof ss === 'string') {
        return sql_template_strings_1.SQL ``.append(ss);
    }
    else if (ss instanceof sql_template_strings_1.SQLStatement) {
        return ss;
    }
    const sql = sql_template_strings_1.SQL ``;
    if (ss) {
        ss.map((s, i) => {
            const u = args[i];
            if (u === undefined) {
                sql.append(s);
            }
            else if (u instanceof sql_template_strings_1.SQLStatement) {
                sql.append(s).append(u);
            }
            else {
                sql.append(s).append(sql_template_strings_1.SQL `${u}`);
            }
        });
    }
    return sql;
}
exports.SQL = SQL;
function joinSQL(sqls, separator) {
    return sqls.slice(1).reduce((prev, c) => SQL(prev).append(SQL(separator)).append(c), SQL(sqls[0]));
}
exports.joinSQL = joinSQL;
